diff -r 92489cdc94d1 src/share/vm/adlc/filebuff.hpp
--- a/src/share/vm/adlc/filebuff.hpp	Tue Dec 04 16:28:18 2007 -0800
+++ b/src/share/vm/adlc/filebuff.hpp	Wed Dec 12 20:05:28 2007 +0200
@@ -27,7 +27,8 @@
 #if _MSC_VER >= 1300  // Visual C++ 7.0 or later
 #include <iostream>
 #else
-#include <iostream.h>
+#include <iostream>
+using namespace std;
 #endif
 
 // STRUCTURE FOR HANDLING INPUT AND OUTPUT FILES